--version 1.2
--## Choco ##--

local relay_names = {
	['IRC'] = '',
	['IRC_'] = '',
	['VOA'] = '%[IRC%] ',
}

local function extractIRCName(msg, header)
	local header = header or ''
	
	if msg and type(msg)=='string' then
		local msg_no_header = msg:match("^"..header.."(.*)") --remove header from front of msg
		if not msg_no_header then return end
		
		if  msg_no_header:sub(1, 1) == "<" then
			return msg_no_header:sub(2)
		elseif msg_no_header:sub(1, 2) == "* " then
			return msg_no_header:sub(3)
		else return end
	else return end
end

local chatreceiver_old = chatreceiver.OnEvent
function chatreceiver:OnEvent(event, data)
	if event == "CHAT_MSG_CHANNEL_EMOTE" or event == "CHAT_MSG_CHANNEL_EMOTE_ACTIVE" then
		if relay_names[data.name] then
			local irc_name = extractIRCName(data.msg, relay_names[data.name])
			
			if irc_name then
				for _,name in ipairs(Ignore.GetIgnoreList() or {}) do
					if string.sub(irc_name, 1, name:len()):lower() == name:lower() then return end --on ignore list: don't display msg
				end
			end
		end
	end
	chatreceiver_old(chatreceiver, event, data)
end

--EVENT NOTES:
--Event: CHAT_MSG_CHANNEL_EMOTE_ACTIVE - Data:
--	1: (table)	channelid=100,msg="[IRC] <CrazySpence> 30min til Capture the flag! get the plugin at www.voupr.com 30mil prize",name="VOA",faction=3
--[100] VOA [IRC] <CrazySpence> 30min til Capture the flag! get the plugin at www.voupr.com 30mil prize

--Event: CHAT_MSG_CHANNEL_EMOTE_ACTIVE - Data:
--	1: (table)	channelid=9,msg="[IRC] * Chocolateer is testing",name="VOA",faction=3
--[9] VOA [IRC] * Chocolateer is testing